package async;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;
import java.util.ListIterator;
import java.util.Random;

import javax.annotation.Resource;
import javax.jws.Oneway;
import javax.jws.WebMethod;
import javax.jws.WebService;
import javax.jws.soap.SOAPBinding;
import javax.jws.soap.SOAPBinding.ParameterStyle;
import javax.jws.soap.SOAPBinding.Style;
import javax.jws.soap.SOAPBinding.Use;
import javax.xml.ws.Endpoint;
import javax.xml.ws.WebServiceContext;

import sample.client.Student;

@WebService(serviceName = "Students", portName = "StudentsPort", targetNamespace = "http://asu.dgtu.donetsk.ua/ex/students")
@SOAPBinding(style = Style.DOCUMENT, use = Use.LITERAL, parameterStyle = ParameterStyle.WRAPPED)
public class StudentService {
	private static List<Student> studentList = new ArrayList<Student>();
	private static final int NAMES_COUNT = 6;
	private static final String GROUP_NAME = "ИУСм15";
	private static final int STUDENT_COUNT = 10;
	private String firstNamesMale[] = { "Иванов", "Петров", "Сидоров", "Сафонов", "Кучеренко", "Петренко" };
	private String lastNamesMale[] = { "Иван", "Петр", "Сидор", "Сергей", "Василий", "Аристарх" };
	private Random rnd = new Random(System.currentTimeMillis());

	{
		studentList.clear();
		for (int i=0; i<STUDENT_COUNT; i++) {
			studentList.add(generate());
		}
	}

	private Student generate() {
		int firstNameIdx = rnd.nextInt(NAMES_COUNT);
		int lastNameIdx = rnd.nextInt(NAMES_COUNT);
		Student s = new Student();
		s.setFirstName(firstNamesMale[firstNameIdx]);
		s.setLastName(lastNamesMale[lastNameIdx]);
		s.setAge(rnd.nextInt(40));
		s.setTranscriptNum("Z"+rnd.nextInt());
		s.setGroup(GROUP_NAME);
		return s;
	}

	@WebMethod
	public List<Student> getStudentList() {
		 try {
	            Thread.sleep(1000*60); // Sleep for 1 minute
	            return studentList;
		 } catch(InterruptedException e) {
			 e.printStackTrace();
		 }
		 return null;
	}

	 public static void main(String args[]) {
	        Endpoint.publish("http://localhost:82/Students", new StudentService());
	  }
}
