package sample;

import java.util.stream.IntStream;

import javax.jws.Oneway;
import javax.jws.WebMethod;
import javax.jws.WebService;
import javax.jws.soap.SOAPBinding;
import javax.jws.soap.SOAPBinding.ParameterStyle;
import javax.jws.soap.SOAPBinding.Style;
import javax.jws.soap.SOAPBinding.Use;

@WebService(serviceName = "PassExam", portName = "PassExamPort", targetNamespace = "http://asu.dgtu.donetsk.ua/ex/passexam")
@SOAPBinding(style = Style.DOCUMENT, use = Use.LITERAL, parameterStyle = ParameterStyle.WRAPPED)
public class ExamService {

	@WebMethod(operationName = "CreateStatement")
	public ExamStatement createStatement(Subject subject, String teacherName, Student[] students) {
		ExamStatement statement = new ExamStatement();
		statement.setSubject(subject);
		statement.setTeacherName(teacherName);
		statement.setStudents(students);
		statement.setEuMarks(new String[students.length]);
		statement.setMarks(new int[students.length]);
		return statement;
	}

	@WebMethod(operationName = "Pass")
	public ExamStatement pass(ExamStatement statement, Student student, int mark) {
		Student[] students = statement.getStudents();
		int ids[] = IntStream.range(0, students.length)
				.filter(i -> students[i].getTranscriptNum().equals(student.getTranscriptNum())).toArray();
		if (ids.length == 1) {
			statement.getMarks()[ids[0]] = mark;
			System.out.println("Mark set: " + statement.getMarks()[ids[0]]);
		}
		return statement;
	}

	@WebMethod(operationName = "asnPass")
	@Oneway()
	public ExamStatement asnPass(ExamStatement statement, Student student, int mark) {
		Student[] students = statement.getStudents();
		int ids[] = IntStream.range(0, students.length)
				.filter(i -> students[i].getTranscriptNum().equals(student.getTranscriptNum())).toArray();
		if (ids.length == 1) {
			statement.getMarks()[ids[0]] = mark;
			System.out.println("Mark set: " + statement.getMarks()[ids[0]]);
		}
		return statement;
	} 
}
