package sample.client;

import java.net.MalformedURLException;
import java.net.URL;
import java.util.Arrays;
import java.util.Random;

import javax.xml.namespace.QName;

public class ExamClient {
	private final static QName PASSEXAM_QNAME = new QName("http://asu.dgtu.donetsk.ua/ex/passexam", "PassExam");
	
	private static URL getWSDLURL(String urlStr) {
		URL url = null;
		try {
			url = new URL(urlStr);
		} catch (MalformedURLException e) {
			e.printStackTrace();
			throw new RuntimeException(e);
		}
		return url;
	}
	
	private static final int NAMES_COUNT = 6;
	private static final String GROUP_NAME = "15";
	private static final int STUDENT_COUNT = 10;
	private String firstNamesMale[] = { "", "", "", "", "", "" };
	private String lastNamesMale[] = { "", "", "", "", "", "" };
	private Random rnd = new Random(System.currentTimeMillis());
	
	private Student generate() {
		int firstNameIdx = rnd.nextInt(NAMES_COUNT);
		int lastNameIdx = rnd.nextInt(NAMES_COUNT);
		Student s = new Student();
		s.setFirstName(firstNamesMale[firstNameIdx]);
		s.setLastName(lastNamesMale[lastNameIdx]);
		s.setAge(rnd.nextInt(40));
		s.setTranscriptNum("Z"+rnd.nextInt());
		s.setGroup(GROUP_NAME);
		return s;
	}
	
	private void process(URL url) {
		PassExam svc = new PassExam(url, PASSEXAM_QNAME);
		ExamService examSvcPort =  svc.getPassExamPort();
		Subject subj = new Subject();
		subj.setCheckType(CheckType.EXAM);
		subj.setHoursTotal(144);
		subj.setHoursLec(32);
		subj.setHoursLabs(16);
		subj.setName("");
		subj.setHasCourseProject(true);		
		Student[] students = new Student[STUDENT_COUNT];
		for (int i = 0; i< STUDENT_COUNT; i++) {
			students[i] = generate();
		}
		ExamStatement stm = examSvcPort.createStatement(subj, " ..", Arrays.asList(students));
		examSvcPort.pass(stm, students[1], 5);
	}

	public static void main(String[] args) {
		URL url = getWSDLURL("http://192.168.88.5:8084/ExamSvcWeb/exampass?wsdl");
		ExamClient client = new ExamClient();
		client.process(url);
	}
}
